<?php

namespace Teknisa\FIN\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

  /*
   * Class relatorioCustomizavelCurvaAbcClientesFactory 
   * @package Teknisa\FIN\Factory
   */
class Rec01400RelatorioCustomizavelCurvaAbcClientesFactory {

    protected $connection;
    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    public function executaProcedureCurvaAbcsClientesFactory($cdEmpresa, $cdCliente, $cdTipoConta, $cdStatus,
        $vencInicio,$vencFim,$dtIniBaixa,$dtFimBaixa, $tdCurvaGeral, $idCurva) {
        // var_dump(['entrou aqui']); die;
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GRAVA_CURVA_ABC_CLIENTE');
            $procedure->addParam(new Param('P_EMPRESA',         Param::PARAM_INPUT,     $cdEmpresa,         Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CLIENTE',         Param::PARAM_INPUT,     $cdCliente,         Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_TIPOCONTA',       Param::PARAM_INPUT,     $cdTipoConta,       Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_STATUS',          Param::PARAM_INPUT,     $cdStatus,          Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTINIVENC',       Param::PARAM_INPUT,     $vencInicio,        Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTFINVENC',       Param::PARAM_INPUT,     $vencFim,           Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTINIBAIXA',      Param::PARAM_INPUT,     $dtIniBaixa,        Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTFINBAIXA',      Param::PARAM_INPUT,     $dtFimBaixa,        Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_TDTBAIXAREC',     Param::PARAM_INPUT,     $tdCurvaGeral,      Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDCURVAGERAL',    Param::PARAM_INPUT,     $idCurva,           Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRSEQCURVAABCCLI',Param::PARAM_OUTPUT,    '',                 Param::PARAM_TYPE_STR, 20));
            $outPut   = $procedure->execute();
            return $outPut['P_NRSEQCURVAABCCLI'];
            
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    
    // consulta não esta sendo utilizada
    public function buscaDadosRelatorio($param){
        
        $sql = "SELECT NRSEQCURVAABCCLI, DECODE(IDCURVAGERAL,'G','Geral',CDEMPRESA||'-'||NMEMPRESA) AS EMPRESA,
                'Curva '||IDTPCURVAABC AS TIPOCURVA,
                NRINSJURCLIE, IDTPIJURCLIE, NMRAZSOCCLIE,
                DTATUAVENREC, DSCONTAREC,
                NRNOTAFISC||'/'||CDSERIE AS DSDOCSERIE,
                CDFILIEMIT, NMFILIAL,
                DTEMISSAO, DTBAIXAREC,
                VRATUAREC, VRPERC
                FROM CURVAABCCLITEMP
                WHERE NRSEQCURVAABCCLI IN ".$param." 
                ORDER BY CDEMPRESA, IDTPCURVAABC, NMRAZSOCCLIE, VRATUAREC DESC";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
}