var bco33001_RelatorioGestaoFluxoCaixa_Controller = function(ScreenService, General, templateManager, ZHPromise, restEngine, ZhFilterPreferences){

    this.openFilterRelatorio = function(widget) {
	    ZhFilterPreferences.openFilterWidget(widget);
	    
	};
	
	this.setFilterFluxoCaixa = function(preference){
        var relatorioGestaoFluxoCaixaGrid = templateManager.container.getWidget('relatorioGestaoFluxoCaixaGrid');
        var filtro = preference.FILTER_ROW;
        
		var cdempresa   = filtro.CDEMPRESA;
		var datainicial = filtro.DTENTRSAID.start;
		var datafinal   = filtro.DTENTRSAID.end;
		var cdreducont  = filtro.hasOwnProperty('CDREDUCONT')  ? filtro.CDREDUCONT.join('_')  : null;
		var cdcliente   = filtro.hasOwnProperty('CDCLIENTE')   ? filtro.CDCLIENTE.join('_')   : null;
		var cdtpctreceb = filtro.hasOwnProperty('CDTPCTRECEB') ? filtro.CDTPCTRECEB.join('_') : null;
		var cdforneced  = filtro.hasOwnProperty('CDFORNECED')  ? filtro.CDFORNECED.join('_')  : null;
		var cdtpctpagar = filtro.hasOwnProperty('CDTPCTPAGAR') ? filtro.CDTPCTPAGAR.join('_') : null;
		var idstatb     = filtro.hasOwnProperty('IDSTATB')     ? filtro.IDSTATB.join('_')     : null;
        
        relatorioGestaoFluxoCaixaGrid.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA'   : filter.value = (cdempresa)   ? cdempresa   : 'T';
                    break;
                case 'DTINICIAL'   : filter.value = (datainicial) ? datainicial : null;
                    break;
                case 'DTFINAL'     : filter.value = (datafinal)   ? datafinal   : null;
                    break;
                case 'CDREDUCONT'  : filter.value = (cdreducont)  ? cdreducont  : 'T';
                    break;
                case 'CDCLIENTE'   : filter.value = (cdcliente)   ? cdcliente   : 'T';
                    break;
                case 'CDTPCTRECEB' : filter.value = (cdtpctreceb) ? cdtpctreceb : 'T';
                    break;
                case 'CDFORNECED'  : filter.value = (cdforneced)  ? cdforneced  : 'T';
                    break;
                case 'CDTPCTPAGAR' : filter.value = (cdtpctpagar) ? cdtpctpagar : 'T';
                    break;
                case 'IDSTATB'     : filter.value = (idstatb)     ? idstatb     : 'T';
                    break;
            }
        });
        
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        
        delete preference.CUSTOM_FILTER_ROW.CDEMPRESA;
        delete preference.CUSTOM_FILTER_ROW.NMEMPRESA;
        delete preference.CUSTOM_FILTER_ROW.DTENTRSAID;
        delete preference.CUSTOM_FILTER_ROW.CDREDUCONT;
        delete preference.CUSTOM_FILTER_ROW.DSCONTCORR;
        delete preference.CUSTOM_FILTER_ROW.CDCLIENTE;
        delete preference.CUSTOM_FILTER_ROW.CDTPCTRECEB;
        delete preference.CUSTOM_FILTER_ROW.CDFORNECED;
        delete preference.CUSTOM_FILTER_ROW.CDTPCTPAGAR;
        delete preference.CUSTOM_FILTER_ROW.IDSTATB;
        
        
        var saldoContaCorrenteGrid = templateManager.container.getWidget('saldoContaCorrenteGrid');
        
        saldoContaCorrenteGrid.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDREDUCONT'  : filter.value = (cdreducont)  ? cdreducont  : 'T';
                    break;
            }
        });
        
        
        var titulosReceberVencidosGrid = templateManager.container.getWidget('titulosReceberVencidosGrid');
        
        titulosReceberVencidosGrid.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA'   : filter.value = (cdempresa)   ? cdempresa   : 'T';
                    break;
            }
        });
    };
	
	this.setStripeRelatorio = function(widget, preference){
        var stripe       = templateManager.container.getWidget('stripe');
        
        stripe.currentRow.EMPRESA    = preference.FILTER_ROW.CDEMPRESA + ' - ' + preference.FILTER_ROW.NMEMPRESA;
        stripe.currentRow.DTINICIAL  = preference.FILTER_ROW.DTENTRSAID.start;
        stripe.currentRow.DTFINAL    = preference.FILTER_ROW.DTENTRSAID.end;
        stripe.currentRow.CDBANCO    = preference.FILTER_ROW.CDBANCO;
        stripe.currentRow.CDAGENCIA  = preference.FILTER_ROW.CDAGENCIAMASK;
        stripe.currentRow.CDCONTCORR = preference.FILTER_ROW.CDCONTCORRMASK;
        stripe.currentRow.DSCONTCORR = preference.FILTER_ROW.DSCONTCORR;
    };
    
    this.calcSaldoContas = function(filtro){
        var soma = 0;
        
        filtro.VRSDOCCORR.forEach(function(data){
            soma = parseFloat(parseFloat(parseFloat(soma).toFixed(2)) + parseFloat(parseFloat(data).toFixed(2))).toFixed(2);
        });
        
        return soma;
    };
	
    this.setMascCnpjCpf = function(widget) {
	    var data = widget.dataSource.data;
	    var inscFormatada;
	    
	    data.forEach(function(value){
	        if(value.NRINSJURFORNCLIE){
    	        if(value.NRINSJURFORNCLIE.length === 14)      inscFormatada = value.NRINSJURFORNCLIE.substr(0, 2) + '.' + value.NRINSJURFORNCLIE.substr(2, 3) + '.' + value.NRINSJURFORNCLIE.substr(5, 3) + '/' + value.NRINSJURFORNCLIE.substr(8, 4) + '-' + value.NRINSJURFORNCLIE.substr(12, 2);
                else if(value.NRINSJURFORNCLIE.length === 11) inscFormatada = value.NRINSJURFORNCLIE.substr(0, 3) + '.' + value.NRINSJURFORNCLIE.substr(3, 3) + '.' + value.NRINSJURFORNCLIE.substr(6, 3) + '-' + value.NRINSJURFORNCLIE.substr(9, 2);
                else inscFormatada = null;
	        }else inscFormatada = null;
            
            value.NRINSJURFORNCLIE = inscFormatada?inscFormatada:value.NRINSJURFORNCLIE;
	    });
	};
	
    this.changeEmpresa = function(args) {
        var widget = args.owner.field.widget;
	    var cdempresa  = widget.currentRow.CDEMPRESA;
        var cdreducont = widget.getField('CDREDUCONT');
        
	    
	    if(cdreducont.dataSourceFilter[0].value != cdempresa){
            cdreducont.dataSourceFilter[0].value = cdempresa;
            cdreducont.setValue("");
            cdreducont.readOnly = cdempresa ? false : true;
            
            cdreducont.reload();
            templateManager.updateTemplate();
	    }
    };
    
       
};
    
    


Configuration(function (ContextRegister){
    ContextRegister.register('Bco33001_RelatorioGestaoFluxoCaixa_Controller', bco33001_RelatorioGestaoFluxoCaixa_Controller);
});